
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Education_levelsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const education_levels = await db.education_levels.create(
            {
                id: data.id || undefined,
        
        level: data.level
        ||
        null
            ,
            
        name: data.name
        ||
        null
            ,
            
        grade_start: data.grade_start
        ||
        null
            ,
            
        grade_end: data.grade_end
        ||
        null
            ,
            
        active: data.active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await education_levels.setSchool( data.school || null, {
            transaction,
        });
        

        

        

        return education_levels;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const education_levelsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                level: item.level
            ||
            null
            ,
            
                name: item.name
            ||
            null
            ,
            
                grade_start: item.grade_start
            ||
            null
            ,
            
                grade_end: item.grade_end
            ||
            null
            ,
            
                active: item.active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const education_levels = await db.education_levels.bulkCreate(education_levelsData, { transaction });

        // For each item created, replace relation files
        

        return education_levels;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const education_levels = await db.education_levels.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.level !== undefined) updatePayload.level = data.level;
        
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.grade_start !== undefined) updatePayload.grade_start = data.grade_start;
        
        
        if (data.grade_end !== undefined) updatePayload.grade_end = data.grade_end;
        
        
        if (data.active !== undefined) updatePayload.active = data.active;
        
        
        updatePayload.updatedById = currentUser.id;

        await education_levels.update(updatePayload, {transaction});

        
        
        if (data.school !== undefined) {
            await education_levels.setSchool(
              
              data.school,
              
              { transaction }
            );
        }
        

        
        

        

        return education_levels;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const education_levels = await db.education_levels.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of education_levels) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of education_levels) {
                await record.destroy({transaction});
            }
        });


        return education_levels;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const education_levels = await db.education_levels.findByPk(id, options);

        await education_levels.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await education_levels.destroy({
            transaction
        });

        return education_levels;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const education_levels = await db.education_levels.findOne(
            { where },
            { transaction },
        );

        if (!education_levels) {
            return education_levels;
        }

        const output = education_levels.get({plain: true});

        
        
        
        
        
        
        
        output.classes_education_level = await education_levels.getClasses_education_level({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.fee_definitions_education_level = await education_levels.getFee_definitions_education_level({
            transaction
        });
        
        
        
        
        
        
        output.school = await education_levels.getSchool({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userSchools = (user && user.schools?.id) || null;
        

        
        if (userSchools) {
            if (options?.currentUser?.schoolsId) {
                where.schoolsId = options.currentUser.schoolsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.schools,
        as: 'school',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'education_levels',
                        'name',
                        filter.name,
                    ),
                };
            }
            

            
            

            
            if (filter.grade_startRange) {
                const [start, end] = filter.grade_startRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    grade_start: {
                    ...where.grade_start,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    grade_start: {
                    ...where.grade_start,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.grade_endRange) {
                const [start, end] = filter.grade_endRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    grade_end: {
                    ...where.grade_end,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    grade_end: {
                    ...where.grade_end,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.level) {
                where = {
                    ...where,
                level: filter.level,
            };
            }
            
            if (filter.active) {
                where = {
                    ...where,
                active: filter.active,
            };
            }
            


      
      if (filter.school) {
        const listItems = filter.school.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          schoolId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.schoolsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.education_levels.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'education_levels',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.education_levels.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

